#include "reg51.h"
#include "intrins.h"

char code eeprom _at_ 0x5000;

sfr     P0M1    =   0x93;
sfr     P0M0    =   0x94;
sfr     P1M1    =   0x91;
sfr     P1M0    =   0x92;
sfr     P2M1    =   0x95;
sfr     P2M0    =   0x96;
sfr     P3M1    =   0xb1;
sfr     P3M0    =   0xb2;
sfr     P4M1    =   0xb3;
sfr     P4M0    =   0xb4;
sfr     P5M1    =   0xc9;
sfr     P5M0    =   0xca;

sfr     IAP_DATA    =   0xC2;
sfr     IAP_ADDRH   =   0xC3;
sfr     IAP_ADDRL   =   0xC4;
sfr     IAP_CMD     =   0xC5;
sfr     IAP_TRIG    =   0xC6;
sfr     IAP_CONTR   =   0xC7;
sfr     IAP_TPS     =   0xF5;

void IapIdle()
{
    IAP_CONTR = 0;                              //رIAP
    IAP_CMD = 0;                                //Ĵ
    IAP_TRIG = 0;                               //Ĵ
    IAP_ADDRH = 0x80;                           //ַõIAP
    IAP_ADDRL = 0;
}

char IapRead(int addr)
{
    char dat;

    IAP_CONTR = 0x80;                           //ʹIAP
    IAP_TPS = 12;                               //õȴ12MHz
    IAP_CMD = 1;                                //IAP
    IAP_ADDRL = addr;                           //IAP͵ַ
    IAP_ADDRH = addr >> 8;                      //IAPߵַ
    IAP_TRIG = 0x5a;                            //д(0x5a)
    IAP_TRIG = 0xa5;                            //д(0xa5)
    _nop_();
    dat = IAP_DATA;                             //IAP
    IapIdle();                                  //رIAP

    return dat;
}

void IapProgram(int addr, char dat)
{
    IAP_CONTR = 0x80;                           //ʹIAP
    IAP_TPS = 12;                               //õȴ12MHz
    IAP_CMD = 2;                                //IAPд
    IAP_ADDRL = addr;                           //IAP͵ַ
    IAP_ADDRH = addr >> 8;                      //IAPߵַ
    IAP_DATA = dat;                             //дIAP
    IAP_TRIG = 0x5a;                            //д(0x5a)
    IAP_TRIG = 0xa5;                            //д(0xa5)
    _nop_();
    IapIdle();                                  //رIAP
}

void IapErase(int addr)
{
    IAP_CONTR = 0x80;                           //ʹIAP
    IAP_TPS = 12;                               //õȴ12MHz
    IAP_CMD = 3;                                //IAP
    IAP_ADDRL = addr;                           //IAP͵ַ
    IAP_ADDRH = addr >> 8;                      //IAPߵַ
    IAP_TRIG = 0x5a;                            //д(0x5a)
    IAP_TRIG = 0xa5;                            //д(0xa5)
    _nop_();                                    //
    IapIdle();                                  //رIAP
}

void main()
{
	unsigned int i=0x100;
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0xff;
    P2M1 = 0x00;
    P3M0 = 0xfc;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
	P2=0;
	
    P2 = IapRead(0);                      
    IapErase(0);
    P2 = IapRead(0);                       
    IapProgram(0, 0x55);					//0x0200ַд0x55
    P2 = IapRead(0);                        //0x0200ַ
	
	
	while(0x55!=( *((char code *)i))){//
		
		i++;
		if(i==0){
			P3=0x03;		//ûҵд
			while (1);	
		}
	}
	
	P2=i;					//Ѿҵд,ݵַΪi
	
    while (1);
}

